#include <string>
#include <vector>
#include <iostream>
#include <iomanip>
#include <algorithm>

using std::vector;
using std::string;
using std::cin;
using std::cout;
using std::ostream;
using std::endl;

bool is_not_palindrome(const string& s) {
	return !equal(s.begin(), s.end(), s.rbegin());
}
void output(vector<string> words) {
	for (vector<string>::const_iterator iter = words.begin(); iter != words.end(); ++iter) {
		cout << (*iter) << endl;
	}
}
bool compare(const string &s1, const string &s2) {
	return s1.size() > s2.size();
}
int main() {
	vector<string> words;
	vector<string> palindromes;
	string s;
	
	// Read the words
	while(cin >> s) {
		words.push_back(s);
	}
	
	// Extract palindromes
	remove_copy_if(words.begin(), words.end(), back_inserter(palindromes), is_not_palindrome);
	
	// Sort palindromes (length)
	sort(palindromes.begin(), palindromes.end(), compare);

	// Output
	cout << endl << "Alle Wrter" << endl;
	output(words);
	cout << endl << "Palindrome, der lnge nach sortiert:" << endl;
	output(palindromes);
	
	return 0;
}

